# Gdk::Window Class Reference

A Gdk::Window is a rectangular region on the screen. More...

Inherits Gdk::Drawable.

Collaboration diagram for Gdk::Window:

[legend]

List of all members.

## Public Member Functions

virtual | ~Window ()
GdkWindow* | gobj ()
| Provides access to the underlying C GObject.
const GdkWindow* | gobj () const
| Provides access to the underlying C GObject.
GdkWindow* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
WindowType | get_window_type () const
| Gets the type of the window.
void | show ()
void | hide ()
| For toplevel windows, withdraws them, so they will no longer be known to the window manager; for all windows, unmaps them, so they won't be displayed.
void | withdraw ()
| Withdraws a window (unmaps it and asks the window manager to forget about it).
void | show_unraised ()
| Shows a Gdk::Window onscreen, but does not modify its stacking order.
void | move (int x, int y)
| Repositions a window relative to its parent window.
void | resize (int width, int height)
| Resizes window; for toplevel windows, asks the window manager to resize the window.
void | move_resize (int x, int y, int width, int height)
| Equivalent to calling gdk_window_move() and gdk_window_resize(), except that both operations are performed at once, avoiding strange visual effects.
void | reparent (const Glib::RefPtr< Window >& new_parent, int x, int y)
void | clear ()
void | clear_area (int x, int y, int width, int height)
| Clears an area of window to the background color or background pixmap.
void | clear_area_e (int x, int y, int width, int height)
| Like gdk_window_clear_area(), but also generates an expose event for the cleared area.
void | raise ()
| Raises window to the top of the Z-order (stacking order), so that other windows with the same parent window appear below window.
void | lower ()
| Lowers window to the bottom of the Z-order (stacking order), so that other windows with the same parent window appear above window.
void | focus (guint32 timestamp)
void | set_user_data (gpointer user_data)
| For most purposes this function is deprecated in favor of Glib::object_set_data().
void | set_override_redirect (bool override_redirect=true)
void | add_filter (GdkFilterFunc function, gpointer data)
void | remove_filter (GdkFilterFunc function, gpointer data)
| Remove a filter previously added with gdk_window_add_filter().
void | scroll (int dx, int dy)
void | move_region (const Region& region, int dx, int dy)
| Move the part of window indicated by region by dy pixels in the Y direction and dx pixels in the X direction.
void | shape_combine_mask (const Glib::RefPtr< Bitmap >& mask, int x, int y)
| Applies a shape mask to window.
void | unset_shape_combine_mask ()
void | shape_combine_region (const Region& shape_region, int offset_x, int offset_y)
void | set_child_shapes ()
void | set_composited (bool composited=TRUE)
void | merge_child_shapes ()
void | input_shape_combine_mask (const Glib::RefPtr< Bitmap >& mask, int x, int y)
| Like gdk_window_shape_combine_mask(), but the shape applies only to event handling.
void | input_shape_combine_region (const Region& shape_region, int offset_x, int offset_y)
| Like gdk_window_shape_combine_region(), but the shape applies only to event handling.
void | set_child_input_shapes ()
| Sets the input shape mask of window to the union of input shape masks for all children of window, ignoring the input shape mask of window itself.
void | merge_child_input_shapes ()
| Merges the input shape masks for any child windows into the input shape mask for window.
bool | is_visible () const
| Checks whether the window has been mapped (with gdk_window_show() or gdk_window_show_unraised()).
bool | is_viewable () const
WindowState | get_state () const
| Gets the bitwise OR of the currently active window state flags, from the Gdk::WindowState enumeration.
bool | set_static_gravities (bool use_static=true)
void | set_type_hint (WindowTypeHint hint)
| The application can use this call to provide a hint to the window manager about the functionality of a window.
WindowTypeHint | get_type_hint ()
void | set_modal_hint (bool modal=true)
| The application can use this hint to tell the window manager that a certain window has modal behaviour.
void | set_geometry_hints (const Geometry& geometry, WindowHints geom_mask)
| Sets the geometry hints for window.
void | begin_paint_rect (Rectangle& rectangle)
| A convenience wrapper around gdk_window_begin_paint_region() which creates a rectangular region for you.
void | begin_paint_region (const Region& region)
| Indicates that you are beginning the process of redrawing region.
void | end_paint ()
| Indicates that the backing store created by the most recent call to gdk_window_begin_paint_region() should be copied onscreen and deleted, leaving the next-most-recent backing store or no backing store at all as the active paint region.
void | set_title (const Glib::ustring& title)
| Sets the title of a toplevel window, to be displayed in the titlebar.
void | set_role (const Glib::ustring& role)
void | set_startup_id (const Glib::ustring& startup_id)
| When using GTK+, typically you should use gtk_window_set_startup_id() instead of this low-level function.
void | set_transient_for (const Glib::RefPtr< Window >& parent)
| Indicates to the window manager that window is a transient dialog associated with the application window parent.
void | set_background (const Color& color)
| Sets the background color of window.
void | set_back_pixmap (const Glib::RefPtr< Pixmap >& pixmap, bool parent_relative=true)
| Sets the background pixmap of window.
void | unset_back_pixmap ()
| Unsets the background pixmap of window so that the window will have no background.
void | set_cursor (const Cursor& cursor)
| Sets the mouse pointer for a Gdk::Window.
void | set_cursor ()
| Use the parent window's cursor.
void | get_user_data (gpointer* data)
| Retrieves the user data for window, which is normally the widget that window belongs to.
void | get_geometry (int& x, int& y, int& width, int& height, int& depth) const
| Any of the return location arguments to this function may be `0`, if you aren't interested in getting the value of that field.
void | get_position (int& x, int& y) const
| Obtains the position of the window as reported in the most-recently-processed Gdk::EventConfigure.
int | get_origin (int& x, int& y) const
| Obtains the position of a window in root window coordinates.
void | get_root_origin (int& x, int& y) const
| Obtains the top-left corner of the window manager frame in root window coordinates.
void | get_frame_extents (Rectangle& rect)
| Obtains the bounding box of the window, including window manager titlebar/borders if any.
Glib::RefPtr< Window > | get_pointer (int& x, int& y, ModifierType& mask)
Glib::RefPtr< Window > | get_parent ()
| Obtains the parent of window, as known to GDK.
Glib::RefPtr< const Window > | get_parent () const
| Obtains the parent of window, as known to GDK.
Glib::RefPtr< Window > | get_toplevel ()
Glib::RefPtr< const Window > | get_toplevel () const
Glib::ListHandle< Glib::RefPtr < Window > > | get_children ()
Glib::ListHandle< Glib::RefPtr < const Window > > | get_children () const
EventMask | get_events () const
| Gets the event mask for window.
void | set_events (EventMask event_mask)
| The event mask for a window determines which events will be reported for that window.
void | set_icon_list (const Glib::ListHandle< Glib::RefPtr< Gdk::Pixbuf > >& pixbufs)
| Sets a list of icons for the window.
void | set_icon (const Glib::RefPtr< Window >& icon_window, const Glib::RefPtr< Pixmap >& pixmap, const Glib::RefPtr< Bitmap >& mask)
| Sets the icon of window as a pixmap or window.
void | set_icon (const Glib::RefPtr< Window >& icon_window, const Glib::RefPtr< Pixmap >& pixmap)
void | unset_icon ()
void | set_icon_name (const Glib::ustring& name)
| Windows may have a name used while minimized, distinct from the name they display in their titlebar.
void | set_group (const Glib::RefPtr< Window >& leader)
| Sets the group leader window for window.
Glib::RefPtr< Window > | get_group ()
Glib::RefPtr< const Window > | get_group () const
void | set_decorations (WMDecoration decorations)
bool | get_decorations (WMDecoration& decorations) const
| Returns: `true` if the window has decorations set, `false` otherwise.
void | set_functions (WMFunction functions)
void | beep ()
| Emits a short beep associated to window in the appropriate display, if supported.
void | iconify ()
void | deiconify ()
| Attempt to deiconify (unminimize) window.
void | stick ()
| "Pins" a window such that it's on all workspaces and does not scroll with viewports, for window managers that have scrollable viewports.
void | unstick ()
| Reverse operation for gdk_window_stick(); see gdk_window_stick(), and gtk_window_unstick().
void | maximize ()
| Maximizes the window.
void | unmaximize ()
| Unmaximizes the window.
void | register_dnd ()
void | begin_resize_drag (WindowEdge edge, int button, int root_x, int root_y, guint32 timestamp)
| Begins a window resize operation (for a toplevel window).
void | begin_move_drag (int button, int root_x, int root_y, guint32 timestamp)
| Begins a window move operation (for a toplevel window).
void | invalidate_rect (const Rectangle& rect, bool invalidate_children)
| A convenience wrapper around gdk_window_invalidate_region() which invalidates a rectangular region.
void | invalidate (bool invalidate_children)
| A convenience wrapper around invalidate_region() which invalidates the whole region.
void | invalidate_region (const Region& region, bool invalidate_children=true)
| Adds region to the update area for window.
Region | get_update_area ()
| Transfers ownership of the update area from window to the caller of the function.
void | freeze_updates ()
| Temporarily freezes a window such that it won't receive expose events.
void | thaw_updates ()
void | process_updates (bool update_children)
| Sends one or more expose events to window.
void | get_internal_paint_info (Glib::RefPtr< Drawable >& real_drawable, int& x_offset, int& y_offset) const
void | enable_synchronized_configure ()
| Indicates that the application will cooperate with the window system in synchronizing the window repaint with the window manager during resizing operations.
void | configure_finished ()
| Signal to the window system that the application has finished handling Configure events it has received.
void | set_skip_taskbar_hint (bool skips_taskbar=true)
| Toggles whether a window should appear in a task list or window list.
void | set_skip_pager_hint (bool skips_pager=true)
| Toggles whether a window should appear in a pager (workspace switcher, or other desktop utility program that displays a small thumbnail representation of the windows on the desktop).
void | set_urgency_hint (bool urgent=true)
void | fullscreen ()
void | unfullscreen ()
| Moves the window out of fullscreen mode.
GrabStatus | pointer_grab (bool owner_events, EventMask event_mask, const Glib::RefPtr< const Window >& confine_to, const Cursor& cursor, guint32 time_)
GrabStatus | pointer_grab (bool owner_events, EventMask event_mask, const Cursor& cursor, guint32 timestamp)
| Grabs the pointer to a specific window.
GrabStatus | pointer_grab (bool owner_events, EventMask event_mask, guint32 timestamp)
| Grabs the pointer to a specific window.
GrabStatus | keyboard_grab (bool owner_events, guint32 timestamp)
void | set_keep_above (bool setting=true)
| Set if window must be kept above other windows.
void | set_keep_below (bool setting=true)
void | set_opacity (double opacity)
| Request the windowing system to make window partially transparent, with opacity 0 being fully transparent and 1 fully opaque.
void | set_accept_focus (bool accept_focus=true)
| Setting accept_focus to `false` hints the desktop environment that the window doesn't want to receive input focus.
void | set_focus_on_map (bool focus_on_map)
| Setting focus_on_map to `false` hints the desktop environment that the window doesn't want to receive input focus when it is mapped.

## Static Public Member Functions

static Glib::RefPtr< Window > | create (const Glib::RefPtr< Window >& parent, GdkWindowAttr* attributes, int attributes_mask)
static void | set_sm_client_id (const Glib::ustring& sm_client_id)
| Sets the <literal>SM_CLIENT_ID</literal> property on the application's leader window so that the window manager can save the application's state using the X11R6 ICCCM session management protocol.
static void | unset_sm_client_id ()
static Glib::ListHandle < Glib::RefPtr< Window > > | get_toplevels ()
static void | process_all_updates ()
| Calls gdk_window_process_updates() for all windows (see Gdk::Window) in the application.
static void | set_debug_updates (bool setting=true)
| With update debugging enabled, calls to gdk_window_invalidate_region() clear the invalidated region of the screen to a noticeable color, and GDK pauses for a short time before sending exposes to windows during gdk_window_process_updates().
static void | constrain_size (const Geometry& geometry, guint flags, int width, int height, int& new_width, int& new_height)
| Constrains a desired width and height according to a set of geometry hints (such as minimum and maximum size).
static void | pointer_ungrab (guint32 timestamp)
| Ungrabs the pointer on the default display, if it is grabbed by this application.
static void | keyboard_ungrab (guint32 timestamp)
| Ungrabs the keyboard on the default display, if it is grabbed by this application.

## Protected Member Functions

| Window (const Glib::RefPtr< Window >& parent, GdkWindowAttr* attributes, int attributes_mask)

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr< Gdk::Window > | wrap (GdkWindowObject* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

A Gdk::Window is a rectangular region on the screen.

It's a low-level object, used to implement high-level objects such as Gtk::Widget and Gtk::Window on the GTK+ level. A Gtk::Window is a toplevel window, the thing a user might think of as a "window" with a titlebar and so on; a Gtk::Window may contain many Gdk::Windows. For example, each Gtk::Button has a Gdk::Window associated with it.

## Constructor& Destructor Documentation

virtual Gdk::Window::~Window | ( |  | ) | `[virtual]`

Gdk::Window::Window | ( | const Glib::RefPtr< Window >& | parent,
|  | GdkWindowAttr * | attributes,
|  | int | attributes_mask |
| ) |  |  | `[protected]`

## Member Function Documentation

void Gdk::Window::add_filter | ( | GdkFilterFunc | function,
|  | gpointer | data |
| ) |  |  |

void Gdk::Window::beep | ( |  | ) |

Emits a short beep associated to window in the appropriate display, if supported.

Otherwise, emits a short beep on the display just as Gdk::Display::beep().

Since gtkmm 2.12:

void Gdk::Window::begin_move_drag | ( | int | button,
|  | int | root_x,
|  | int | root_y,
|  | guint32 | timestamp |
| ) |  |  |

Begins a window move operation (for a toplevel window).

You might use this function to implement a "window move grip," for example. The function works best with window managers that support the <ulink url="http://www.freedesktop.org/Standards/wm-spec">Extended Window Manager Hints</ulink>, but has a fallback implementation for other window managers.

Parameters:

  | button | The button being used to drag.
  | root_x | Root window X coordinate of mouse click that began the drag.
  | root_y | Root window Y coordinate of mouse click that began the drag.
  | timestamp | Timestamp of mouse click that began the drag.

void Gdk::Window::begin_paint_rect | ( | Rectangle& | rectangle | ) |

A convenience wrapper around gdk_window_begin_paint_region() which creates a rectangular region for you.

See gdk_window_begin_paint_region() for details.

Parameters:

  | rectangle | Rectangle you intend to draw to.

void Gdk::Window::begin_paint_region | ( | const Region& | region | ) |

Indicates that you are beginning the process of redrawing region.

A backing store (offscreen buffer) large enough to contain region will be created. The backing store will be initialized with the background color or background pixmap for window. Then, all drawing operations performed on window will be diverted to the backing store. When you call gdk_window_end_paint(), the backing store will be copied to window, making it visible onscreen. Only the part of window contained in region will be modified; that is, drawing operations are clipped to region.

The net result of all this is to remove flicker, because the user sees the finished product appear all at once when you call gdk_window_end_paint(). If you draw to window directly without calling gdk_window_begin_paint_region(), the user may see flicker as individual drawing operations are performed in sequence. The clipping and background-initializing features of gdk_window_begin_paint_region() are conveniences for the programmer, so you can avoid doing that work yourself.

When using GTK+, the widget system automatically places calls to gdk_window_begin_paint_region() and gdk_window_end_paint() around emissions of the expose_event signal. That is, if you're writing an expose event handler, you can assume that the exposed area in Gdk::EventExpose has already been cleared to the window background, is already set as the clip region, and already has a backing store. Therefore in most cases, application code need not call gdk_window_begin_paint_region(). (You can disable the automatic calls around expose events on a widget-by-widget basis by calling gtk_widget_set_double_buffered().)

If you call this function multiple times before calling the matching gdk_window_end_paint(), the backing stores are pushed onto a stack. gdk_window_end_paint() copies the topmost backing store onscreen, subtracts the topmost region from all other regions in the stack, and pops the stack. All drawing operations affect only the topmost backing store in the stack. One matching call to gdk_window_end_paint() is required for each call to gdk_window_begin_paint_region().

Parameters:

  | region | Region you intend to draw to.

void Gdk::Window::begin_resize_drag | ( | WindowEdge | edge,
|  | int | button,
|  | int | root_x,
|  | int | root_y,
|  | guint32 | timestamp |
| ) |  |  |

Begins a window resize operation (for a toplevel window).

You might use this function to implement a "window resize grip," for example; in fact Gtk::Statusbar uses it. The function works best with window managers that support the <ulink url="http://www.freedesktop.org/Standards/wm-spec">Extended Window Manager Hints</ulink>, but has a fallback implementation for other window managers.

Parameters:

  | edge | The edge or corner from which the drag is started.
  | button | The button being used to drag.
  | root_x | Root window X coordinate of mouse click that began the drag.
  | root_y | Root window Y coordinate of mouse click that began the drag.
  | timestamp | Timestamp of mouse click that began the drag (use gdk_event_get_time()).

void Gdk::Window::clear | ( |  | ) |

void Gdk::Window::clear_area | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height |
| ) |  |  |

Clears an area of window to the background color or background pixmap.

Parameters:

  | x | X coordinate of rectangle to clear.
  | y | Y coordinate of rectangle to clear.
  | width | Width of rectangle to clear.
  | height | Height of rectangle to clear.

void Gdk::Window::clear_area_e | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height |
| ) |  |  |

Like gdk_window_clear_area(), but also generates an expose event for the cleared area.

This function has a stupid name because it dates back to the mists time, pre-GDK-1.0.

Parameters:

  | x | X coordinate of rectangle to clear.
  | y | Y coordinate of rectangle to clear.
  | width | Width of rectangle to clear.
  | height | Height of rectangle to clear.

void Gdk::Window::configure_finished | ( |  | ) |

Signal to the window system that the application has finished handling Configure events it has received.

Window Managers can use this to better synchronize the frame repaint with the application. GTK+ applications will automatically call this function when appropriate.

This function can only be called if gdk_window_enable_synchronized_configure() was called previously.

Since gtkmm 2.6:

static void Gdk::Window::constrain_size | ( | const Geometry& | geometry,
|  | guint | flags,
|  | int | width,
|  | int | height,
|  | int & | new_width,
|  | int & | new_height |
| ) |  |  | `[static]`

Constrains a desired width and height according to a set of geometry hints (such as minimum and maximum size).

Parameters:

  | geometry | A Gdk::Geometry structure.
  | flags | A mask indicating what portions of geometry are set.
  | width | Desired width of window.
  | height | Desired height of the window.
  | new_width | Location to store resulting width.
  | new_height | Location to store resulting height.

static Glib::RefPtr<Window> Gdk::Window::create | ( | const Glib::RefPtr< Window >& | parent,
|  | GdkWindowAttr * | attributes,
|  | int | attributes_mask |
| ) |  |  | `[static]`

void Gdk::Window::deiconify | ( |  | ) |

Attempt to deiconify (unminimize) window.

On X11 the window manager may choose to ignore the request to deiconify. When using GTK+, use gtk_window_deiconify() instead of the Gdk::Window variant. Or better yet, you probably want to use gtk_window_present(), which raises the window, focuses it, unminimizes it, and puts it on the current desktop.

void Gdk::Window::enable_synchronized_configure | ( |  | ) |

Indicates that the application will cooperate with the window system in synchronizing the window repaint with the window manager during resizing operations.

After an application calls this function, it must call gdk_window_configure_finished() every time it has finished all processing associated with a set of Configure events. Toplevel GTK+ windows automatically use this protocol.

On X, calling this function makes window participate in the _NET_WM_SYNC_REQUEST window manager protocol.

Since gtkmm 2.6:

void Gdk::Window::end_paint | ( |  | ) |

Indicates that the backing store created by the most recent call to gdk_window_begin_paint_region() should be copied onscreen and deleted, leaving the next-most-recent backing store or no backing store at all as the active paint region.

See gdk_window_begin_paint_region() for full details. It is an error to call this function without a matching gdk_window_begin_paint_region() first.

void Gdk::Window::focus | ( | guint32 | timestamp | ) |

void Gdk::Window::freeze_updates | ( |  | ) |

Temporarily freezes a window such that it won't receive expose events.

The window will begin receiving expose events again when gdk_window_thaw_updates() is called. If gdk_window_freeze_updates() has been called more than once, gdk_window_thaw_updates() must be called an equal number of times to begin processing exposes.

void Gdk::Window::fullscreen | ( |  | ) |

Glib::ListHandle< Glib::RefPtr<const Window> > Gdk::Window::get_children | ( |  | ) | const

Glib::ListHandle< Glib::RefPtr<Window> > Gdk::Window::get_children | ( |  | ) |

bool Gdk::Window::get_decorations | ( | WMDecoration& | decorations | ) | const

Returns: `true` if the window has decorations set, `false` otherwise.

Parameters:

  | decorations | The window decorations will be written here.

Returns:
  `true` if the window has decorations set, `false` otherwise.

EventMask Gdk::Window::get_events | ( |  | ) | const

Gets the event mask for window.

See gdk_window_set_events().

Returns:
  Event mask for window.

void Gdk::Window::get_frame_extents | ( | Rectangle& | rect | ) |

Obtains the bounding box of the window, including window manager titlebar/borders if any.

The frame position is given in root window coordinates. To get the position of the window itself (rather than the frame) in root window coordinates, use gdk_window_get_origin().

Parameters:

  | rect | Rectangle to fill with bounding box of the window frame.

void Gdk::Window::get_geometry | ( | int & | x,
|  | int & | y,
|  | int & | width,
|  | int & | height,
|  | int & | depth |
| ) |  |  | const

Any of the return location arguments to this function may be `0`, if you aren't interested in getting the value of that field.

The X and Y coordinates returned are relative to the parent window of window, which for toplevels usually means relative to the window decorations (titlebar, etc.) rather than relative to the root window (screen-size background window).

On the X11 platform, the geometry is obtained from the X server, so reflects the latest position of window; this may be out-of-sync with the position of window delivered in the most-recently-processed Gdk::EventConfigure. gdk_window_get_position() in contrast gets the position from the most recent configure event.

<note> If window is not a toplevel, it is <emphasis>much</emphasis> better to call gdk_window_get_position() and Gdk::Drawable::get_size() instead, because it avoids the roundtrip to the X server and because Gdk::Drawable::get_size() supports the full 32-bit coordinate space, whereas gdk_window_get_geometry() is restricted to the 16-bit coordinates of X11. </note>

Parameters:

  | x | Return location for X coordinate of window (relative to its parent).
  | y | Return location for Y coordinate of window (relative to its parent).
  | width | Return location for width of window.
  | height | Return location for height of window.
  | depth | Return location for bit depth of window.

Glib::RefPtr<const Window> Gdk::Window::get_group | ( |  | ) | const

Glib::RefPtr<Window> Gdk::Window::get_group | ( |  | ) |

void Gdk::Window::get_internal_paint_info | ( | Glib::RefPtr< Drawable >& | real_drawable,
|  | int & | x_offset,
|  | int & | y_offset |
| ) |  |  | const

int Gdk::Window::get_origin | ( | int & | x,
|  | int & | y |
| ) |  |  | const

Obtains the position of a window in root window coordinates.

(Compare with gdk_window_get_position() and gdk_window_get_geometry() which return the position of a window relative to its parent window.)

Parameters:

  | x | Return location for X coordinate.
  | y | Return location for Y coordinate.

Returns:
  Not meaningful, ignore.

Glib::RefPtr<const Window> Gdk::Window::get_parent | ( |  | ) | const

Obtains the parent of window, as known to GDK.

Does not query the X server; thus this returns the parent as passed to gdk_window_new(), not the actual parent. This should never matter unless you're using Xlib calls mixed with GDK calls on the X11 platform. It may also matter for toplevel windows, because the window manager may choose to reparent them.

Returns:
  Parent of window.

Glib::RefPtr<Window> Gdk::Window::get_parent | ( |  | ) |

Obtains the parent of window, as known to GDK.

Does not query the X server; thus this returns the parent as passed to gdk_window_new(), not the actual parent. This should never matter unless you're using Xlib calls mixed with GDK calls on the X11 platform. It may also matter for toplevel windows, because the window manager may choose to reparent them.

Returns:
  Parent of window.

Glib::RefPtr<Window> Gdk::Window::get_pointer | ( | int & | x,
|  | int & | y,
|  | ModifierType& | mask |
| ) |  |  |

void Gdk::Window::get_position | ( | int & | x,
|  | int & | y |
| ) |  |  | const

Obtains the position of the window as reported in the most-recently-processed Gdk::EventConfigure.

Contrast with gdk_window_get_geometry() which queries the X server for the current window position, regardless of which events have been received or processed.

The position coordinates are relative to the window's parent window.

Parameters:

  | x | X coordinate of window.
  | y | Y coordinate of window.

void Gdk::Window::get_root_origin | ( | int & | x,
|  | int & | y |
| ) |  |  | const

Obtains the top-left corner of the window manager frame in root window coordinates.

Parameters:

  | x | Return location for X position of window frame.
  | y | Return location for Y position of window frame.

WindowState Gdk::Window::get_state | ( |  | ) | const

Gets the bitwise OR of the currently active window state flags, from the Gdk::WindowState enumeration.

Returns:
  Window state bitfield.

Glib::RefPtr<const Window> Gdk::Window::get_toplevel | ( |  | ) | const

Glib::RefPtr<Window> Gdk::Window::get_toplevel | ( |  | ) |

static Glib::ListHandle< Glib::RefPtr<Window> > Gdk::Window::get_toplevels | ( |  | ) | `[static]`

WindowTypeHint Gdk::Window::get_type_hint | ( |  | ) |

Region Gdk::Window::get_update_area | ( |  | ) |

Transfers ownership of the update area from window to the caller of the function.

That is, after calling this function, window will no longer have an invalid/dirty region; the update area is removed from window and handed to you. If a window has no update area, gdk_window_get_update_area() returns `0`. You are responsible for calling gdk_region_destroy() on the returned region if it's non-`0`.

Returns:
  The update area for window.

void Gdk::Window::get_user_data | ( | gpointer * | data | ) |

Retrieves the user data for window, which is normally the widget that window belongs to.

See gdk_window_set_user_data().

Parameters:

  | data | Return location for user data.

WindowType Gdk::Window::get_window_type | ( |  | ) | const

Gets the type of the window.

See Gdk::WindowType.

Returns:
  Type of window.

const GdkWindow* Gdk::Window::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Gdk::Drawable.

GdkWindow* Gdk::Window::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Gdk::Drawable.

GdkWindow* Gdk::Window::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented from Gdk::Drawable.

void Gdk::Window::hide | ( |  | ) |

For toplevel windows, withdraws them, so they will no longer be known to the window manager; for all windows, unmaps them, so they won't be displayed.

Normally done automatically as part of gtk_widget_hide().

void Gdk::Window::iconify | ( |  | ) |

void Gdk::Window::input_shape_combine_mask | ( | const Glib::RefPtr< Bitmap >& | mask,
|  | int | x,
|  | int | y |
| ) |  |  |

Like gdk_window_shape_combine_mask(), but the shape applies only to event handling.

Mouse events which happen while the pointer position corresponds to an unset bit in the mask will be passed on the window below window.

An input shape is typically used with RGBA windows. The alpha channel of the window defines which pixels are invisible and allows for nicely antialiased borders, and the input shape controls where the window is "clickable".

On the X11 platform, this requires version 1.1 of the shape extension.

On the Win32 platform, this functionality is not present and the function does nothing.

Since gtkmm 2.10:

Parameters:

  | mask | Shape mask, or `0`.
  | x | X position of shape mask with respect to window.
  | y | Y position of shape mask with respect to window.

void Gdk::Window::input_shape_combine_region | ( | const Region& | shape_region,
|  | int | offset_x,
|  | int | offset_y |
| ) |  |  |

Like gdk_window_shape_combine_region(), but the shape applies only to event handling.

Mouse events which happen while the pointer position corresponds to an unset bit in the mask will be passed on the window below window.

An input shape is typically used with RGBA windows. The alpha channel of the window defines which pixels are invisible and allows for nicely antialiased borders, and the input shape controls where the window is "clickable".

On the X11 platform, this requires version 1.1 of the shape extension.

On the Win32 platform, this functionality is not present and the function does nothing.

Since gtkmm 2.10:

Parameters:

  | shape_region | Region of window to be non-transparent.
  | offset_x | X position of shape_region in window coordinates.
  | offset_y | Y position of shape_region in window coordinates.

void Gdk::Window::invalidate | ( | bool | invalidate_children | ) |

A convenience wrapper around invalidate_region() which invalidates the whole region.

See invalidate_region() for details.

Parameters:

  | invalidate_children | Whether to also invalidate child windows.

void Gdk::Window::invalidate_rect | ( | const Rectangle& | rect,
|  | bool | invalidate_children |
| ) |  |  |

A convenience wrapper around gdk_window_invalidate_region() which invalidates a rectangular region.

See gdk_window_invalidate_region() for details.

Parameters:

  | rect | Rectangle to invalidate or `0` to invalidate the whole window.
  | invalidate_children | Whether to also invalidate child windows.

void Gdk::Window::invalidate_region | ( | const Region& | region,
|  | bool | invalidate_children = `true` |
| ) |  |  |

Adds region to the update area for window.

The update area is the region that needs to be redrawn, or "dirty region." The call gdk_window_process_updates() sends one or more expose events to the window, which together cover the entire update area. An application would normally redraw the contents of window in response to those expose events.

GDK will call gdk_window_process_all_updates() on your behalf whenever your program returns to the main loop and becomes idle, so normally there's no need to do that manually, you just need to invalidate regions that you know should be redrawn.

The invalidate_children parameter controls whether the region of each child window that intersects region will also be invalidated. If `false`, then the update area for child windows will remain unaffected. See gdk_window_invalidate_maybe_recurse if you need fine grained control over which children are invalidated.

Parameters:

  | region | A Gdk::Region.
  | invalidate_children | `true` to also invalidate child windows.

bool Gdk::Window::is_viewable | ( |  | ) | const

bool Gdk::Window::is_visible | ( |  | ) | const

Checks whether the window has been mapped (with gdk_window_show() or gdk_window_show_unraised()).

Returns:
  `true` if the window is mapped.

GrabStatus Gdk::Window::keyboard_grab | ( | bool | owner_events,
|  | guint32 | timestamp |
| ) |  |  |

static void Gdk::Window::keyboard_ungrab | ( | guint32 | timestamp | ) | `[static]`

Ungrabs the keyboard on the default display, if it is grabbed by this application.

Parameters:

  | time | A timestamp from a Gdk::Event, or Gdk::CURRENT_TIME if no timestamp is available.

void Gdk::Window::lower | ( |  | ) |

Lowers window to the bottom of the Z-order (stacking order), so that other windows with the same parent window appear above window.

This is true whether or not the other windows are visible.

If window is a toplevel, the window manager may choose to deny the request to move the window in the Z-order, gdk_window_lower() only requests the restack, does not guarantee it.

Note that gdk_window_show() raises the window again, so don't call this function before gdk_window_show(). (Try gdk_window_show_unraised().)

void Gdk::Window::maximize | ( |  | ) |

Maximizes the window.

If the window was already maximized, then this function does nothing.

On X11, asks the window manager to maximize window, if the window manager supports this operation. Not all window managers support this, and some deliberately ignore it or don't have a concept of "maximized"; so you can't rely on the maximization actually happening. But it will happen with most standard window managers, and GDK makes a best effort to get it to happen.

On Windows, reliably maximizes the window.

void Gdk::Window::merge_child_input_shapes | ( |  | ) |

Merges the input shape masks for any child windows into the input shape mask for window.

i.e. the union of all input masks for window and its children will become the new input mask for window. See gdk_window_input_shape_combine_mask().

This function is distinct from gdk_window_set_child_input_shapes() because it includes window's input shape mask in the set of shapes to be merged.

Since gtkmm 2.10:

void Gdk::Window::merge_child_shapes | ( |  | ) |

void Gdk::Window::move | ( | int | x,
|  | int | y |
| ) |  |  |

Repositions a window relative to its parent window.

For toplevel windows, window managers may ignore or modify the move; you should probably use gtk_window_move() on a Gtk::Window widget anyway, instead of using GDK functions. For child windows, the move will reliably succeed.

If you're also planning to resize the window, use gdk_window_move_resize() to both move and resize simultaneously, for a nicer visual effect.

Parameters:

  | x | X coordinate relative to window's parent.
  | y | Y coordinate relative to window's parent.

void Gdk::Window::move_region | ( | const Region& | region,
|  | int | dx,
|  | int | dy |
| ) |  |  |

Move the part of window indicated by region by dy pixels in the Y direction and dx pixels in the X direction.

The portions of region that not covered by the new position of region are invalidated.

Child windows are not moved.

Since gtkmm 2.8:

Parameters:

  | region | The Gdk::Region to move.
  | dx | Amount to move in the X direction.
  | dy | Amount to move in the Y direction.

void Gdk::Window::move_resize | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height |
| ) |  |  |

Equivalent to calling gdk_window_move() and gdk_window_resize(), except that both operations are performed at once, avoiding strange visual effects.

(i.e. the user may be able to see the window first move, then resize, if you don't use gdk_window_move_resize().)

Parameters:

  | x | New X position relative to window's parent.
  | y | New Y position relative to window's parent.
  | width | New width.
  | height | New height.

GrabStatus Gdk::Window::pointer_grab | ( | bool | owner_events,
|  | EventMask | event_mask,
|  | guint32 | timestamp |
| ) |  |  |

Grabs the pointer to a specific window.

Requires a corresponding call to pointer_ungrab().

Arguments:

Parameters:

  | owner_events | Specifies whether events will be reported as is, or relative to the window.
  | event_mask | Masks only interesting events.
  | timestamp | Specifies the time.

GrabStatus Gdk::Window::pointer_grab | ( | bool | owner_events,
|  | EventMask | event_mask,
|  | const Cursor& | cursor,
|  | guint32 | timestamp |
| ) |  |  |

Grabs the pointer to a specific window.

Requires a corresponding call to pointer_ungrab().

Arguments:

Parameters:

  | owner_events | Specifies whether events will be reported as is, or relative to the window.
  | event_mask | Masks only interesting events.
  | cursor | Changes the cursor for the duration of the grab.
  | timestamp | Specifies the time.

GrabStatus Gdk::Window::pointer_grab | ( | bool | owner_events,
|  | EventMask | event_mask,
|  | const Glib::RefPtr< const Window >& | confine_to,
|  | const Cursor& | cursor,
|  | guint32 | time_ |
| ) |  |  |

static void Gdk::Window::pointer_ungrab | ( | guint32 | timestamp | ) | `[static]`

Ungrabs the pointer on the default display, if it is grabbed by this application.

Parameters:

  | time | A timestamp from a Gdk::Event, or Gdk::CURRENT_TIME if no timestamp is available.

static void Gdk::Window::process_all_updates | ( |  | ) | `[static]`

Calls gdk_window_process_updates() for all windows (see Gdk::Window) in the application.

void Gdk::Window::process_updates | ( | bool | update_children | ) |

Sends one or more expose events to window.

The areas in each expose event will cover the entire update area for the window (see gdk_window_invalidate_region() for details). Normally GDK calls gdk_window_process_all_updates() on your behalf, so there's no need to call this function unless you want to force expose events to be delivered immediately and synchronously (vs. the usual case, where GDK delivers them in an idle handler). Occasionally this is useful to produce nicer scrolling behavior, for example.

Parameters:

  | update_children | Whether to also process updates for child windows.

void Gdk::Window::raise | ( |  | ) |

Raises window to the top of the Z-order (stacking order), so that other windows with the same parent window appear below window.

This is true whether or not the windows are visible.

If window is a toplevel, the window manager may choose to deny the request to move the window in the Z-order, gdk_window_raise() only requests the restack, does not guarantee it.

void Gdk::Window::register_dnd | ( |  | ) |

void Gdk::Window::remove_filter | ( | GdkFilterFunc | function,
|  | gpointer | data |
| ) |  |  |

Remove a filter previously added with gdk_window_add_filter().

Parameters:

  | function | Previously-added filter function.
  | data | User data for previously-added filter function.

void Gdk::Window::reparent | ( | const Glib::RefPtr< Window >& | new_parent,
|  | int | x,
|  | int | y |
| ) |  |  |

void Gdk::Window::resize | ( | int | width,
|  | int | height |
| ) |  |  |

Resizes window; for toplevel windows, asks the window manager to resize the window.

The window manager may not allow the resize. When using GTK+, use gtk_window_resize() instead of this low-level GDK function.

Windows may not be resized below 1x1.

If you're also planning to move the window, use gdk_window_move_resize() to both move and resize simultaneously, for a nicer visual effect.

Parameters:

  | width | New width of the window.
  | height | New height of the window.

void Gdk::Window::scroll | ( | int | dx,
|  | int | dy |
| ) |  |  |

void Gdk::Window::set_accept_focus | ( | bool | accept_focus = `true` | ) |

Setting accept_focus to `false` hints the desktop environment that the window doesn't want to receive input focus.

On X, it is the responsibility of the window manager to interpret this hint. ICCCM-compliant window manager usually respect it.

Since gtkmm 2.4:

Parameters:

  | accept_focus | `true` if the window should receive input focus.

void Gdk::Window::set_back_pixmap | ( | const Glib::RefPtr< Pixmap >& | pixmap,
|  | bool | parent_relative = `true` |
| ) |  |  |

Sets the background pixmap of window.

May also be used to set a background of "None" on window, by setting a background pixmap of `0`.

A background pixmap will be tiled, positioning the first tile at the origin of window, or if parent_relative is `true`, the tiling will be done based on the origin of the parent window (useful to align tiles in a parent with tiles in a child).

A background pixmap of `0` means that the window will have no background. A window with no background will never have its background filled by the windowing system, instead the window will contain whatever pixels were already in the corresponding area of the display.

The windowing system will normally fill a window with its background when the window is obscured then exposed, and when you call gdk_window_clear().

Parameters:

  | pixmap | A Gdk::Pixmap, or `0`.
  | parent_relative | Whether the tiling origin is at the origin of window's parent.

void Gdk::Window::set_background | ( | const Color& | color | ) |

Sets the background color of window.

(However, when using GTK+, set the background of a widget with gtk_widget_modify_bg() - if you're an application - or gtk_style_set_background() - if you're implementing a custom widget.)

The color must be allocated; gdk_rgb_find_color() is the best way to allocate a color.

See also gdk_window_set_back_pixmap().

Parameters:

  | color | An allocated Gdk::Color.

void Gdk::Window::set_child_input_shapes | ( |  | ) |

Sets the input shape mask of window to the union of input shape masks for all children of window, ignoring the input shape mask of window itself.

Contrast with gdk_window_merge_child_input_shapes() which includes the input shape mask of window in the masks to be merged.

Since gtkmm 2.10:

void Gdk::Window::set_child_shapes | ( |  | ) |

void Gdk::Window::set_composited | ( | bool | composited = `TRUE` | ) |

void Gdk::Window::set_cursor | ( |  | ) |

Use the parent window's cursor.

For top-level windows this means that it will use the default cursor for the ROOT window.

void Gdk::Window::set_cursor | ( | const Cursor& | cursor | ) |

Sets the mouse pointer for a Gdk::Window.

Use gdk_cursor_new_for_display() or gdk_cursor_new_from_pixmap() to create the cursor. To make the cursor invisible, use Gdk::BLANK_CURSOR. Passing `0` for the cursor argument to gdk_window_set_cursor() means that window will use the cursor of its parent window. Most windows should use this default.

Parameters:

  | cursor | A cursor.

static void Gdk::Window::set_debug_updates | ( | bool | setting = `true` | ) | `[static]`

With update debugging enabled, calls to gdk_window_invalidate_region() clear the invalidated region of the screen to a noticeable color, and GDK pauses for a short time before sending exposes to windows during gdk_window_process_updates().

The net effect is that you can see the invalid region for each window and watch redraws as they occur. This allows you to diagnose inefficiencies in your application.

In essence, because the GDK rendering model prevents all flicker, if you are redrawing the same region 400 times you may never notice, aside from noticing a speed problem. Enabling update debugging causes GTK to flicker slowly and noticeably, so you can see exactly what's being redrawn when, in what order.

The --gtk-debug=updates command line option passed to GTK+ programs enables this debug option at application startup time. That's usually more useful than calling gdk_window_set_debug_updates() yourself, though you might want to use this function to enable updates sometime after application startup time.

Parameters:

  | setting | `true` to turn on update debugging.

void Gdk::Window::set_decorations | ( | WMDecoration | decorations | ) |

void Gdk::Window::set_events | ( | EventMask | event_mask | ) |

The event mask for a window determines which events will be reported for that window.

For example, an event mask including Gdk::BUTTON_PRESS_MASK means the window should report button press events. The event mask is the bitwise OR of values from the Gdk::EventMask enumeration.

Parameters:

  | event_mask | Event mask for window.

void Gdk::Window::set_focus_on_map | ( | bool | focus_on_map | ) |

Setting focus_on_map to `false` hints the desktop environment that the window doesn't want to receive input focus when it is mapped.

focus_on_map should be turned off for windows that aren't triggered interactively (such as popups from network activity).

On X, it is the responsibility of the window manager to interpret this hint. Window managers following the freedesktop.org window manager extension specification should respect it.

Since gtkmm 2.6:

Parameters:

  | focus_on_map | `true` if the window should receive input focus when mapped.

void Gdk::Window::set_functions | ( | WMFunction | functions | ) |

void Gdk::Window::set_geometry_hints | ( | const Geometry& | geometry,
|  | WindowHints | geom_mask |
| ) |  |  |

Sets the geometry hints for window.

Hints flagged in geom_mask are set, hints not flagged in geom_mask are unset. To unset all hints, use a geom_mask of 0 and a geometry of `0`.

This function provides hints to the windowing system about acceptable sizes for a toplevel window. The purpose of this is to constrain user resizing, but the windowing system will typically (but is not required to) also constrain the current size of the window to the provided values and constrain programatic resizing via gdk_window_resize() or gdk_window_move_resize().

Note that on X11, this effect has no effect on windows of type Gdk::WINDOW_TEMP or windows where override redirect has been turned on via gdk_window_set_override_redirect() since these windows are not resizable by the user.

Since you can't count on the windowing system doing the constraints for programmatic resizes, you should generally call gdk_window_constrain_size() yourself to determine appropriate sizes.

Parameters:

  | geometry | Geometry hints.
  | geom_mask | Bitmask indicating fields of geometry to pay attention to.

void Gdk::Window::set_group | ( | const Glib::RefPtr< Window >& | leader | ) |

Sets the group leader window for window.

By default, GDK sets the group leader for all toplevel windows to a global window implicitly created by GDK. With this function you can override this default.

The group leader window allows the window manager to distinguish all windows that belong to a single application. It may for example allow users to minimize/unminimize all windows belonging to an application at once. You should only set a non-default group window if your application pretends to be multiple applications.

Parameters:

  | leader | Group leader window, or `0` to restore the default group leader window.

void Gdk::Window::set_icon | ( | const Glib::RefPtr< Window >& | icon_window,
|  | const Glib::RefPtr< Pixmap >& | pixmap |
| ) |  |  |

void Gdk::Window::set_icon | ( | const Glib::RefPtr< Window >& | icon_window,
|  | const Glib::RefPtr< Pixmap >& | pixmap,
|  | const Glib::RefPtr< Bitmap >& | mask |
| ) |  |  |

Sets the icon of window as a pixmap or window.

If using GTK+, investigate gtk_window_set_default_icon_list() first, and then gtk_window_set_icon_list() and gtk_window_set_icon(). If those don't meet your needs, look at gdk_window_set_icon_list(). Only if all those are too high-level do you want to fall back to gdk_window_set_icon().

Parameters:

  | icon_window | A Gdk::Window to use for the icon, or `0` to unset.
  | pixmap | A Gdk::Pixmap to use as the icon, or `0` to unset.
  | mask | A 1-bit pixmap (Gdk::Bitmap) to use as mask for pixmap, or `0` to have none.

void Gdk::Window::set_icon_list | ( | const Glib::ListHandle< Glib::RefPtr< Gdk::Pixbuf > >& | pixbufs | ) |

Sets a list of icons for the window.

One of these will be used to represent the window when it has been iconified. The icon is usually shown in an icon box or some sort of task bar. Which icon size is shown depends on the window manager. The window manager can scale the icon but setting several size icons can give better image quality since the window manager may only need to scale the icon by a small amount or not at all.

Parameters:

  | pixbufs | A list of pixbufs, of different sizes.

void Gdk::Window::set_icon_name | ( | const Glib::ustring & | name | ) |

Windows may have a name used while minimized, distinct from the name they display in their titlebar.

Most of the time this is a bad idea from a user interface standpoint. But you can set such a name with this function, if you like.

After calling this with a non-`0` name, calls to gdk_window_set_title() will not update the icon title.

Using `0` for name unsets the icon title; further calls to gdk_window_set_title() will again update the icon title as well.

Parameters:

  | name | Name of window while iconified (minimized).

void Gdk::Window::set_keep_above | ( | bool | setting = `true` | ) |

Set if window must be kept above other windows.

If the window was already above, then this function does nothing.

On X11, asks the window manager to keep window above, if the window manager supports this operation. Not all window managers support this, and some deliberately ignore it or don't have a concept of "keep above"; so you can't rely on the window being kept above. But it will happen with most standard window managers, and GDK makes a best effort to get it to happen.

Since gtkmm 2.4:

Parameters:

  | setting | Whether to keep window above other windows.

void Gdk::Window::set_keep_below | ( | bool | setting = `true` | ) |

void Gdk::Window::set_modal_hint | ( | bool | modal = `true` | ) |

The application can use this hint to tell the window manager that a certain window has modal behaviour.

The window manager can use this information to handle modal windows in a special way.

You should only use this on windows for which you have previously called gdk_window_set_transient_for()

Parameters:

  | modal | `true` if the window is modal, `false` otherwise.

void Gdk::Window::set_opacity | ( | double | opacity | ) |

Request the windowing system to make window partially transparent, with opacity 0 being fully transparent and 1 fully opaque.

(Values of the opacity parameter are clamped to the [0,1] range.)

On X11, this works only on X screens with a compositing manager running.

For setting up per-pixel alpha, see Gdk::Screen::get_rgba_colormap(). For making non-toplevel windows translucent, see gdk_window_set_composited().

Since gtkmm 2.12:

Parameters:

  | opacity | Opacity.

void Gdk::Window::set_override_redirect | ( | bool | override_redirect = `true` | ) |

void Gdk::Window::set_role | ( | const Glib::ustring & | role | ) |

void Gdk::Window::set_skip_pager_hint | ( | bool | skips_pager = `true` | ) |

Toggles whether a window should appear in a pager (workspace switcher, or other desktop utility program that displays a small thumbnail representation of the windows on the desktop).

If a window's semantic type as specified with gdk_window_set_type_hint() already fully describes the window, this function should <emphasis>not</emphasis> be called in addition, instead you should allow the window to be treated according to standard policy for its semantic type.

Since gtkmm 2.2:

Parameters:

  | skips_pager | `true` to skip the pager.

void Gdk::Window::set_skip_taskbar_hint | ( | bool | skips_taskbar = `true` | ) |

Toggles whether a window should appear in a task list or window list.

If a window's semantic type as specified with gdk_window_set_type_hint() already fully describes the window, this function should <emphasis>not</emphasis> be called in addition, instead you should allow the window to be treated according to standard policy for its semantic type.

Since gtkmm 2.2:

Parameters:

  | skips_taskbar | `true` to skip the taskbar.

static void Gdk::Window::set_sm_client_id | ( | const Glib::ustring & | sm_client_id | ) | `[static]`

Sets the <literal>SM_CLIENT_ID</literal> property on the application's leader window so that the window manager can save the application's state using the X11R6 ICCCM session management protocol.

See the X Session Management Library documentation for more information on session management and the Inter-Client Communication Conventions Manual (ICCCM) for information on the <literal>WM_CLIENT_LEADER</literal> property. (Both documents are part of the X Window System distribution.)

Parameters:

  | sm_client_id | The client id assigned by the session manager when the connection was opened, or `0` to remove the property.

void Gdk::Window::set_startup_id | ( | const Glib::ustring & | startup_id | ) |

When using GTK+, typically you should use gtk_window_set_startup_id() instead of this low-level function.

Since gtkmm 2.12:

Parameters:

  | startup_id | A string with startup-notification identifier.

bool Gdk::Window::set_static_gravities | ( | bool | use_static = `true` | ) |

void Gdk::Window::set_title | ( | const Glib::ustring & | title | ) |

Sets the title of a toplevel window, to be displayed in the titlebar.

If you haven't explicitly set the icon name for the window (using gdk_window_set_icon_name()), the icon name will be set to title as well. title must be in UTF-8 encoding (as with all user-readable strings in GDK/GTK+). title may not be `0`.

Parameters:

  | title | Title of window.

void Gdk::Window::set_transient_for | ( | const Glib::RefPtr< Window >& | parent | ) |

Indicates to the window manager that window is a transient dialog associated with the application window parent.

This allows the window manager to do things like center window on parent and keep window above parent.

See gtk_window_set_transient_for() if you're using Gtk::Window or Gtk::Dialog.

Parameters:

  | parent | Another toplevel Gdk::Window.

void Gdk::Window::set_type_hint | ( | WindowTypeHint | hint | ) |

The application can use this call to provide a hint to the window manager about the functionality of a window.

The window manager can use this information when determining the decoration and behaviour of the window.

The hint must be set before the window is mapped.

Parameters:

  | hint | A hint of the function this window will have.

void Gdk::Window::set_urgency_hint | ( | bool | urgent = `true` | ) |

void Gdk::Window::set_user_data | ( | gpointer | user_data | ) |

For most purposes this function is deprecated in favor of Glib::object_set_data().

However, for historical reasons GTK+ stores the Gtk::Widget that owns a Gdk::Window as user data on the Gdk::Window. So, custom widget implementations should use this function for that. If GTK+ receives an event for a Gdk::Window, and the user data for the window is non-`0`, GTK+ will assume the user data is a Gtk::Widget, and forward the event to that widget.

Parameters:

  | user_data | User data.

void Gdk::Window::shape_combine_mask | ( | const Glib::RefPtr< Bitmap >& | mask,
|  | int | x,
|  | int | y |
| ) |  |  |

Applies a shape mask to window.

Pixels in window corresponding to set bits in the mask will be visible; pixels in window corresponding to unset bits in the mask will be transparent. This gives a non-rectangular window.

If mask is `0`, the shape mask will be unset, and the x/ y parameters are not used.

On the X11 platform, this uses an X server extension which is widely available on most common platforms, but not available on very old X servers, and occasionally the implementation will be buggy. On servers without the shape extension, this function will do nothing.

This function works on both toplevel and child windows.

Parameters:

  | mask | Shape mask.
  | x | X position of shape mask with respect to window.
  | y | Y position of shape mask with respect to window.

void Gdk::Window::shape_combine_region | ( | const Region& | shape_region,
|  | int | offset_x,
|  | int | offset_y |
| ) |  |  |

void Gdk::Window::show | ( |  | ) |

void Gdk::Window::show_unraised | ( |  | ) |

Shows a Gdk::Window onscreen, but does not modify its stacking order.

In contrast, gdk_window_show() will raise the window to the top of the window stack.

On the X11 platform, in Xlib terms, this function calls XMapWindow() (it also updates some internal GDK state, which means that you can't really use XMapWindow() directly on a GDK window).

void Gdk::Window::stick | ( |  | ) |

"Pins" a window such that it's on all workspaces and does not scroll with viewports, for window managers that have scrollable viewports.

(When using Gtk::Window, gtk_window_stick() may be more useful.)

On the X11 platform, this function depends on window manager support, so may have no effect with many window managers. However, GDK will do the best it can to convince the window manager to stick the window. For window managers that don't support this operation, there's nothing you can do to force it to happen.

void Gdk::Window::thaw_updates | ( |  | ) |

void Gdk::Window::unfullscreen | ( |  | ) |

Moves the window out of fullscreen mode.

If the window was not fullscreen, does nothing.

On X11, asks the window manager to move window out of the fullscreen state, if the window manager supports this operation. Not all window managers support this, and some deliberately ignore it or don't have a concept of "fullscreen"; so you can't rely on the unfullscreenification actually happening. But it will happen with most standard window managers, and GDK makes a best effort to get it to happen.

Since gtkmm 2.2:

void Gdk::Window::unmaximize | ( |  | ) |

Unmaximizes the window.

If the window wasn't maximized, then this function does nothing.

On X11, asks the window manager to unmaximize window, if the window manager supports this operation. Not all window managers support this, and some deliberately ignore it or don't have a concept of "maximized"; so you can't rely on the unmaximization actually happening. But it will happen with most standard window managers, and GDK makes a best effort to get it to happen.

On Windows, reliably unmaximizes the window.

void Gdk::Window::unset_back_pixmap | ( |  | ) |

Unsets the background pixmap of window so that the window will have no background.

A window with no background will never have its background filled by the windowing system, instead the window will contain whatever pixels were already in the corresponding area of the display.

See also:
  set_back_pixmap().

Since gtkmm 2.14:

void Gdk::Window::unset_icon | ( |  | ) |

void Gdk::Window::unset_shape_combine_mask | ( |  | ) |

static void Gdk::Window::unset_sm_client_id | ( |  | ) | `[static]`

void Gdk::Window::unstick | ( |  | ) |

Reverse operation for gdk_window_stick(); see gdk_window_stick(), and gtk_window_unstick().

void Gdk::Window::withdraw | ( |  | ) |

Withdraws a window (unmaps it and asks the window manager to forget about it).

This function is not really useful as gdk_window_hide() automatically withdraws toplevel windows before hiding them.

## Friends And Related Function Documentation

Glib::RefPtr< Gdk::Window > wrap | ( | GdkWindowObject * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gdkmm/window.h